<html> 
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8"/> 
    <title>TC Track Map</title>
	<link rel="stylesheet" href="stylesheet01.css" type="text/css"/>
    <script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=ABQIAAAAKWzb0J160NNDIMQLbFypIBQrFoHLwWjfyrDEpaGPDrKAeI100hRXgRGBpNzZCIw9w3KhNl_0xfLDfw" type="text/javascript"></script>
	
	<SCRIPT src="label_marker.js" type=text/javascript></SCRIPT>

	<?php include("tctrackinfo.php");?>

    <script type="text/javascript">
	function nm2km(val){
		val = Math.round(val*1.852,0);
		return val;
	}

	function calculateDistance(lan1, long1, lan2, long2) {
		var polyOptions = {geodesic:true};
		var distanceLine = new GPolyline([new GLatLng(lan1,long1),new GLatLng(lan2,long2)], "#ff0000", 5, 0.7, polyOptions);
		var distance = distanceLine.getLength();
		distance = distance / 1000;
		distance = Math.round(distance,0);
		return distance;
	}

	function tcCategory(wind){
			var category="";
		
			if(wind>=240)
				category="Super Typhoon";
			else if(wind>=185)
				category="Super Typhoon";
			else if(wind>=150)
				category="Severe Typhoon";
			else if(wind>=118)
				category="Typhoon";
			else if(wind>=88)
				category="Severe Tropical Storm";
			else if(wind>=63)
				category="Tropical Storm";
			else if(wind>=38)
				category="Tropical Depression";

		return category
	}

	function tcCenterIcon(wind){
			var iconstr="";
		
			if(wind>=240)
				iconstr="pic/tc_center_b.gif";
			else if(wind>=185)
				iconstr="pic/tc_center_b.gif";
			else if(wind>=150)
				iconstr="pic/tc_center_p.gif";
			else if(wind>=118)
				iconstr="pic/tc_center_r.gif";
			else if(wind>=88)
				iconstr="pic/tc_center_o.gif";
			else if(wind>=63)
				iconstr="pic/tc_center_y.gif";
			else if(wind>=38)
				iconstr="pic/tc_center.gif";

		return iconstr;
	}


	var distanceToHK_hk=0;
	var distanceToHK_us=0;

	var map=null;

    function initialize() {

      if (GBrowserIsCompatible()) {

			function createTCCenterMarker(point,org,strength) {

			    var baseIcon = new GIcon(G_DEFAULT_ICON);

				/*
					baseIcon.shadow = "http://www.google.com/mapfiles/shadow50.png";
					baseIcon.iconSize = new GSize(20, 34);
					baseIcon.shadowSize = new GSize(37, 34);
					baseIcon.iconAnchor = new GPoint(9, 34);
					baseIcon.infoWindowAnchor = new GPoint(9, 2);
				*/

				var tcIcon=new GIcon(baseIcon); 

				//if (<?php print($hkcenterFlag)?>==0){
					tcIcon.image=tcCenterIcon(strength);
					tcIcon.iconSize=new GSize(30, 30);
					tcIcon.shadowSize = new GSize(0, 0);
					tcIcon.iconAnchor = new GPoint(15, 15);
				//}

				markerOptions = { icon:tcIcon };

				var marker = new GMarker(point, markerOptions);
				
				var message = "";
				
				message='<table bordercolor="black" border="1" cellpadding="1" cellspacing="0" width="220"><tr><td colspan="2"><?php print(' ');print($focus_tc_nameeng); ?> (Latest Position by '+org+')<br>HKT: <?php print($tctrack_current_timestr);?></td></tr>';
				message+='<tr><td>Position:</td><td><nobr><?php print($tctrack_current_latitude);?>N <?php print($tctrack_current_longitude); ?>E</nobr></td></tr>';
				message+='<tr><td><nobr>Distance to HK:</nobr></td><td>'+distanceToHK+'km</td></tr>';
				message+='<tr><td>Category:</td><td>'+tcCategory(strength)+'</td></tr>';
				message+='<tr><td>Intensity:</td><td>'+strength+'km/hr</td></tr>';
				message+='</table>';
			
				GEvent.addListener(marker,"mouseover", function() {
					var myHtml = message;
					map.openInfoWindowHtml(point, myHtml);
				});

				/*
				GEvent.addListener(marker, "mouseout", function() {
				  map.closeInfoWindow();
				});
				*/
				return marker;
			}


			//Setup Map
			var map = new GMap2(document.getElementById("map_canvas"));

			//TC Center
			var distanceLine_hk = new GPolyline([
			<?php
				  print("new GLatLng(22.3,114.2),");

					if ($tctrack_current_hk_latitude[0]!=""){
						print("new GLatLng( $tctrack_current_hk_latitude[0],$tctrack_current_hk_longitude[0])");
					}else{
						print("new GLatLng(0,0)");
					}

			?>
			], "#ff0000", 5, 0.7, polyOptions);


			var distanceLine_us = new GPolyline([
			<?php
				  print("new GLatLng(22.3,114.2),");
					if ($tctrack_current_us_latitude[0]!=""){
						print("new GLatLng( $tctrack_current_us_latitude[0],$tctrack_current_us_longitude[0])");
					}else{
						print("new GLatLng(0,0)");
					}
			?>
			], "#ff0000", 5, 0.7, polyOptions);

			var zoomLevel=4;
			map.setCenter(new GLatLng(<?php print($tctrack_current_latitude)?>,<?php print($tctrack_current_longitude)?>),zoomLevel);

			var distanceToHK=0;

			distanceToHK_hk = distanceLine_hk.getLength();
			distanceToHK_hk = distanceToHK_hk / 1000;
			distanceToHK_hk = Math.round(distanceToHK_hk,0);

			distanceToHK_us = distanceLine_us.getLength();
			distanceToHK_us = distanceToHK_us / 1000;
			distanceToHK_us = Math.round(distanceToHK_us,0);

			
			var positionOrg="<?php echo $tctrack_positionOrg ?>";
			
            if((distanceToHK_hk!=12500)&&(positionOrg=="HK")){
                distanceToHK=distanceToHK_hk;/*positionOrg="HK";*/}
            else if(distanceToHK_us!=12500){
                distanceToHK=distanceToHK_us;/*positionOrg="US";*/}


			if(distanceToHK>0){
				if(distanceToHK<=400){
					zoomLevel=6;
				}
				else if(distanceToHK<=800){
					zoomLevel=5;
				}
			}

			if (distanceToHK<1000){
				map.setCenter(new GLatLng(22.3,114.2),zoomLevel);  //Set HK as center
			}else{
				map.setCenter(new GLatLng(<?php print($tctrack_current_latitude+$map_center_offsetx)?>,<?php print($tctrack_current_longitude-$map_center_offsety)?>),zoomLevel);
			}


			//Draw TC Affecting Area
			if (<?php print($wind_radii_strong_hk)?>>0)	{
					drawCircle(map,new GLatLng(<?php print($tctrack_current_latitude)?>,<?php print($tctrack_current_longitude)?>),nm2km(<?php print($wind_radii_strong_hk)?>),36,"#0000FF",1, 0.3,"#0000FF",0.3);
			}

			if (<?php print($wind_radii_gale_hk)?>>0)	{
					drawCircle(map,new GLatLng(<?php print($tctrack_current_latitude)?>,<?php print($tctrack_current_longitude)?>),nm2km(<?php print($wind_radii_gale_hk)?>),36,"#FFFF00",1, 0.3,"#FFFF00",0.3);
			}

			if (<?php print($wind_radii_storm_hk)?>>0)	{
					drawCircle(map,new GLatLng(<?php print($tctrack_current_latitude)?>,<?php print($tctrack_current_longitude)?>),nm2km(<?php print($wind_radii_storm_hk)?>),36,"#FF9600",1, 0.3,"#FF9600",0.3);
			}

			if (<?php print($wind_radii_hurricane_hk)?>>0)	{
					drawCircle(map,new GLatLng(<?php print($tctrack_current_latitude)?>,<?php print($tctrack_current_longitude)?>),nm2km(<?php print($wind_radii_hurricane_hk)?>),36,"#FF0000",1, 0.3,"#FF0000",0.3);
			}

			//Draw Warning Area
			//var centre = map.getCenter();
			//	function drawCircle(map,center, radius, nodes, liColor, liWidth, liOpa, fillColor, fillOpa)
			drawCircle(map,new GLatLng(22.3,114.2),1200,36,"#CCCCCC",2, 0.5,"", 0);
			drawCircle(map,new GLatLng(22.3,114.2),800,36,"#0000FF",2, 0.2,"", 0);
			drawCircle(map,new GLatLng(22.3,114.2),400,36,"#FF0000",2, 0.2,"", 0);
			drawCircle(map,new GLatLng(22.3,114.2),200,36,"#000000",2, 0.2,"", 0);


			/////////////////////////////////////////////
			//HK TC Track
		
			var polyOptions = {geodesic:true};
			var polyline = new GPolyline([
			<?php
				if($tctrack_current_hk_latitude[0]!=""){
					for ($y=0; $y<count($tctrack_current_hk_latitude);$y++){
					  print("new GLatLng( $tctrack_current_hk_latitude[$y],$tctrack_current_hk_longitude[$y]),");
					}
				}else{
						print("new GLatLng(0,0),");
				}
			?>
			], "#ff0000", 2, 0.5, polyOptions);

			var polyline2 = new GPolyline([
			<?php
				if($tctrack_current_hk_latitude[0]!=""){

					for ($x=0; $x<count($tctrack_forcast_hk_latitude);$x++){
					  print("new GLatLng( $tctrack_forcast_hk_latitude[$x],$tctrack_forcast_hk_longitude[$x]),");
					}
					print("new GLatLng( $tctrack_current_hk_latitude[0],$tctrack_current_hk_longitude[0])");

				}else{
						print("new GLatLng(0,0),");
				}

			?>
			], "#ff0000", 5, 0.7, polyOptions);

			//HK TC Track Icon and Label
			var tcicon_base = new GIcon(G_DEFAULT_ICON);
			
			/*
			tcicon_base.shadow = "http://www.google.com/mapfiles/shadow50.png";
			tcicon_base.iconSize = new GSize(20, 34);
			tcicon_base.shadowSize = new GSize(37, 34);
			tcicon_base.iconAnchor = new GPoint(9, 34);
			tcicon_base.infoWindowAnchor = new GPoint(9, 2);
			*/

			var tcicon_forcast_hk=new GIcon(tcicon_base);
			tcicon_forcast_hk.image="pic/forecast_pos_r.gif";
			tcicon_forcast_hk.iconSize=new GSize(20, 20);
			tcicon_forcast_hk.shadowSize = new GSize(0, 0);
			tcicon_forcast_hk.iconAnchor = new GPoint(10, 10);

			var tcicon_forcast_hk2=new GIcon(tcicon_base);
			tcicon_forcast_hk2.image="pic/forecast_pos_r2.gif";
			tcicon_forcast_hk2.iconSize=new GSize(20, 20);
			tcicon_forcast_hk2.shadowSize = new GSize(0, 0);
			tcicon_forcast_hk2.iconAnchor = new GPoint(10, 10);


			var marker_forcast_hk=[];
			var label_forcast_hk= [];
			var distanceToHK_forcast_hk=0;

			var tctrack_forcast_hk_latitude=[];
			var tctrack_forcast_hk_longitude=[];
			tctrack_forcast_hk_latitude[0]=<?php ($tctrack_forcast_hk_latitude[0]!='')? print($tctrack_forcast_hk_latitude[0]):print('""')?>;
			tctrack_forcast_hk_longitude[0]=<?php ($tctrack_forcast_hk_longitude[0]!='')? print($tctrack_forcast_hk_longitude[0]):print('""')?>;
			tctrack_forcast_hk_latitude[1]=<?php ($tctrack_forcast_hk_latitude[1]!='')? print($tctrack_forcast_hk_latitude[1]):print('""')?>;
			tctrack_forcast_hk_longitude[1]=<?php ($tctrack_forcast_hk_longitude[1]!='')? print($tctrack_forcast_hk_longitude[1]):print('""')?>;
			tctrack_forcast_hk_latitude[2]=<?php ($tctrack_forcast_hk_latitude[2]!='')? print($tctrack_forcast_hk_latitude[2]):print('""')?>;
			tctrack_forcast_hk_longitude[2]=<?php ($tctrack_forcast_hk_longitude[2]!='')? print($tctrack_forcast_hk_longitude[2]):print('""')?>;

			var tctrack_forcast_hk_strength=[];
			tctrack_forcast_hk_strength[0]=<?php ($tctrack_forcast_hk_strength[0]!='')? print($tctrack_forcast_hk_strength[0]):print('""')?>;
			tctrack_forcast_hk_strength[1]=<?php ($tctrack_forcast_hk_strength[1]!='')? print($tctrack_forcast_hk_strength[1]):print('""')?>;
			tctrack_forcast_hk_strength[2]=<?php ($tctrack_forcast_hk_strength[2]!='')? print($tctrack_forcast_hk_strength[2]):print('""')?>;

			var tctrack_forcast_hk_timelabel=[];
			tctrack_forcast_hk_timelabel[0]=' +72hr Forcast by HK<br>HKT: <?php print("$tctrack_forcast_hk_year[0]/$tctrack_forcast_hk_month[0]/$tctrack_forcast_hk_day[0] $tctrack_forcast_hk_hr[0]:0");?>';
			tctrack_forcast_hk_timelabel[1]=' +48hr Forcast by HK<br>HKT: <?php print("$tctrack_forcast_hk_year[1]/$tctrack_forcast_hk_month[1]/$tctrack_forcast_hk_day[1] $tctrack_forcast_hk_hr[1]:0");?>';
			tctrack_forcast_hk_timelabel[2]=' +24hr Forcast by HK<br>HKT: <?php print("$tctrack_forcast_hk_year[2]/$tctrack_forcast_hk_month[2]/$tctrack_forcast_hk_day[2] $tctrack_forcast_hk_hr[2]:0");?>';

			for(i=0; i<3; i++){

				(tctrack_forcast_hk_strength[i]>=118)?markerOptions = { icon:tcicon_forcast_hk2 }:markerOptions = { icon:tcicon_forcast_hk };

				marker_forcast_hk[i] = new GMarker(new GLatLng(tctrack_forcast_hk_latitude[i],tctrack_forcast_hk_longitude[i]), markerOptions);
	
				map.addOverlay(marker_forcast_hk[i]);

				distanceToHK_forcast_hk=calculateDistance(tctrack_forcast_hk_latitude[i],tctrack_forcast_hk_longitude[i], 22.3, 114.2);
				label_forcast_hk[i]='<table bordercolor="black" border="1" cellpadding="1" cellspacing="0" width="220"><tr><td colspan="2"><?php print(' ');print($focus_tc_nameeng);?>'+tctrack_forcast_hk_timelabel[i]+'</td></tr>';
				label_forcast_hk[i]+='<tr><td>Position:</td><td><nobr>'+tctrack_forcast_hk_latitude[i]+'N '+ tctrack_forcast_hk_longitude[i]+'E</nobr></td></tr>';
				label_forcast_hk[i]+='<tr><td><nobr>Distance to HK:</nobr></td><td>'+distanceToHK_forcast_hk+'km</td></tr>';
				label_forcast_hk[i]+='<tr><td>Category:</td><td>'+tcCategory(tctrack_forcast_hk_strength[i])+'</td></tr>';
				label_forcast_hk[i]+='<tr><td>Intensity:</td><td>'+tctrack_forcast_hk_strength[i]+' km/hr</td></tr>';
				label_forcast_hk[i]+='</table>';
			}

			GEvent.addListener(marker_forcast_hk[0],"mouseover", function() {
				map.openInfoWindowHtml(new GLatLng(tctrack_forcast_hk_latitude[0],tctrack_forcast_hk_longitude[0]), label_forcast_hk[0]);
			});

			GEvent.addListener(marker_forcast_hk[1],"mouseover", function() {
				map.openInfoWindowHtml(new GLatLng(tctrack_forcast_hk_latitude[1],tctrack_forcast_hk_longitude[1]), label_forcast_hk[1]);
			});

			GEvent.addListener(marker_forcast_hk[2],"mouseover", function() {
				map.openInfoWindowHtml(new GLatLng(tctrack_forcast_hk_latitude[2],tctrack_forcast_hk_longitude[2]), label_forcast_hk[2]);
			});
			////////////////////////////////////////////

			////////////////////////////////////////////
			//US Track
			var polyline_us = new GPolyline([
			<?php
				if($tctrack_current_us_latitude[0]!=""){

						for ($y=0; $y<count($tctrack_current_us_latitude);$y++){
							print("new GLatLng( $tctrack_current_us_latitude[$y],$tctrack_current_us_longitude[$y]),");
						}
							

				}else{
						print("new GLatLng(0,0),");
				}
			?>
			], "#0000ff", 2, 0.7, polyOptions);

			var polyline_us2 = new GPolyline([
			<?php

				if($tctrack_current_us_latitude[0]!=""){

						print("new GLatLng( $tctrack_current_us_latitude[0],$tctrack_current_us_longitude[0]),");

						for ($x=0; $x<count($tctrack_forcast_us_latitude);$x++){
						  print("new GLatLng( $tctrack_forcast_us_latitude[$x],$tctrack_forcast_us_longitude[$x]),");
						}

				}else{
						print("new GLatLng(0,0),");
				}

			?>
	        ], "#0000ff", 5, 0.7, polyOptions);


			//US TC Track Icon and Label
			var tcicon_forcast_us=new GIcon(tcicon_base);
			tcicon_forcast_us.image="pic/forecast_pos_b.gif";
			tcicon_forcast_us.iconSize=new GSize(20, 20);
			tcicon_forcast_us.shadowSize = new GSize(0, 0);
			tcicon_forcast_us.iconAnchor = new GPoint(10, 10);

			var tcicon_forcast_us2=new GIcon(tcicon_base);
			tcicon_forcast_us2.image="pic/forecast_pos_b2.gif";
			tcicon_forcast_us2.iconSize=new GSize(20, 20);
			tcicon_forcast_us2.shadowSize = new GSize(0, 0);
			tcicon_forcast_us2.iconAnchor = new GPoint(10, 10);

			var marker_forcast_us=[];
			var label_forcast_us= [];
			var distanceToHK_forcast_us=0;

			var tctrack_forcast_us_latitude=[];
			var tctrack_forcast_us_longitude=[];
			tctrack_forcast_us_latitude[0]=<?php ($tctrack_forcast_us_latitude[0]!='')? print($tctrack_forcast_us_latitude[0]):print('""')?>;
			tctrack_forcast_us_longitude[0]=<?php ($tctrack_forcast_us_longitude[0]!='')? print($tctrack_forcast_us_longitude[0]):print('""')?>;
			tctrack_forcast_us_latitude[1]=<?php ($tctrack_forcast_us_latitude[1]!='')? print($tctrack_forcast_us_latitude[1]):print('""')?>;
			tctrack_forcast_us_longitude[1]=<?php ($tctrack_forcast_us_longitude[1]!='')? print($tctrack_forcast_us_longitude[1]):print('""')?>;
			tctrack_forcast_us_latitude[2]=<?php ($tctrack_forcast_us_latitude[2]!='')? print($tctrack_forcast_us_latitude[2]):print('""')?>;
			tctrack_forcast_us_longitude[2]=<?php ($tctrack_forcast_us_longitude[2]!='')? print($tctrack_forcast_us_longitude[2]):print('""')?>;
			tctrack_forcast_us_latitude[3]=<?php ($tctrack_forcast_us_latitude[3]!='')? print($tctrack_forcast_us_latitude[3]):print('""')?>;
			tctrack_forcast_us_longitude[3]=<?php ($tctrack_forcast_us_longitude[3]!='')? print($tctrack_forcast_us_longitude[3]):print('""')?>;
			tctrack_forcast_us_latitude[4]=<?php ($tctrack_forcast_us_latitude[4]!='')? print($tctrack_forcast_us_latitude[4]):print('""')?>;
			tctrack_forcast_us_longitude[4]=<?php ($tctrack_forcast_us_longitude[4]!='')? print($tctrack_forcast_us_longitude[4]):print('""')?>;
			tctrack_forcast_us_latitude[5]=<?php ($tctrack_forcast_us_latitude[5]!='')? print($tctrack_forcast_us_latitude[5]):print('""')?>;
			tctrack_forcast_us_longitude[5]=<?php ($tctrack_forcast_us_longitude[5]!='')? print($tctrack_forcast_us_longitude[5]):print('""')?>;
			tctrack_forcast_us_latitude[6]=<?php ($tctrack_forcast_us_latitude[6]!='')? print($tctrack_forcast_us_latitude[6]):print('""')?>;
			tctrack_forcast_us_longitude[6]=<?php ($tctrack_forcast_us_longitude[6]!='')? print($tctrack_forcast_us_longitude[6]):print('""')?>;


			var tctrack_forcast_us_strength=[];
			tctrack_forcast_us_strength[0]=<?php ($tctrack_forcast_us_strength[0]!='')? print($tctrack_forcast_us_strength[0]):print('""')?>;
			tctrack_forcast_us_strength[1]=<?php ($tctrack_forcast_us_strength[1]!='')? print($tctrack_forcast_us_strength[1]):print('""')?>;
			tctrack_forcast_us_strength[2]=<?php ($tctrack_forcast_us_strength[2]!='')? print($tctrack_forcast_us_strength[2]):print('""')?>;
			tctrack_forcast_us_strength[3]=<?php ($tctrack_forcast_us_strength[3]!='')? print($tctrack_forcast_us_strength[3]):print('""')?>;
			tctrack_forcast_us_strength[4]=<?php ($tctrack_forcast_us_strength[4]!='')? print($tctrack_forcast_us_strength[4]):print('""')?>;
			tctrack_forcast_us_strength[5]=<?php ($tctrack_forcast_us_strength[5]!='')? print($tctrack_forcast_us_strength[5]):print('""')?>;
			tctrack_forcast_us_strength[6]=<?php ($tctrack_forcast_us_strength[6]!='')? print($tctrack_forcast_us_strength[6]):print('""')?>;


			var tctrack_forcast_us_timelabel=[];
			tctrack_forcast_us_timelabel[0]=' +12hr Forcast by US<br>HKT: <?php print(date("Y/m/d H:i", strtotime("$tctrack_forcast_us_year[0]/$tctrack_forcast_us_month[0]/$tctrack_forcast_us_day[0] $tctrack_forcast_us_hr[0]:0")+ 3600*8) );?>';
			tctrack_forcast_us_timelabel[1]=' +24hr Forcast by US<br>HKT: <?php print(date("Y/m/d H:i", strtotime("$tctrack_forcast_us_year[1]/$tctrack_forcast_us_month[1]/$tctrack_forcast_us_day[1] $tctrack_forcast_us_hr[1]:0")+ 3600*8));?>';
			tctrack_forcast_us_timelabel[2]=' +36hr Forcast by US<br>HKT: <?php print(date("Y/m/d H:i", strtotime("$tctrack_forcast_us_year[2]/$tctrack_forcast_us_month[2]/$tctrack_forcast_us_day[2] $tctrack_forcast_us_hr[2]:0")+ 3600*8));?>';
			tctrack_forcast_us_timelabel[3]=' +48hr Forcast by US<br>HKT: <?php print(date("Y/m/d H:i", strtotime("$tctrack_forcast_us_year[3]/$tctrack_forcast_us_month[3]/$tctrack_forcast_us_day[3] $tctrack_forcast_us_hr[3]:0")+ 3600*8));?>';
			tctrack_forcast_us_timelabel[4]=' +72hr Forcast by US<br>HKT: <?php print(date("Y/m/d H:i", strtotime("$tctrack_forcast_us_year[4]/$tctrack_forcast_us_month[4]/$tctrack_forcast_us_day[4] $tctrack_forcast_us_hr[4]:0")+ 3600*8));?>';
			tctrack_forcast_us_timelabel[5]=' +96hr Forcast by US<br>HKT: <?php print(date("Y/m/d H:i", strtotime("$tctrack_forcast_us_year[5]/$tctrack_forcast_us_month[5]/$tctrack_forcast_us_day[5] $tctrack_forcast_us_hr[5]:0")+ 3600*8));?>';
			tctrack_forcast_us_timelabel[6]=' +120hr Forcast by US<br>HKT: <?php print(date("Y/m/d H:i", strtotime("$tctrack_forcast_us_year[6]/$tctrack_forcast_us_month[6]/$tctrack_forcast_us_day[6] $tctrack_forcast_us_hr[6]:0")+ 3600*8));?>';

			i=0;

			for(i=0; i<7; i++){

				(nm2km(tctrack_forcast_us_strength[i])>=118)?markerOptions = { icon:tcicon_forcast_us2 }:markerOptions = { icon:tcicon_forcast_us };

				marker_forcast_us[i] = new GMarker(new GLatLng(tctrack_forcast_us_latitude[i],tctrack_forcast_us_longitude[i]), markerOptions);
	
				map.addOverlay(marker_forcast_us[i]);

				if(tctrack_forcast_us_latitude[i]!=''){

					distanceToHK_forcast_us=calculateDistance(tctrack_forcast_us_latitude[i],tctrack_forcast_us_longitude[i], 22.3, 114.2);
					label_forcast_us[i]='<table bordercolor="black" border="1" cellpadding="1" cellspacing="0" width="220"><tr><td colspan="2"><?php print(' ');print($focus_tc_nameeng);?>'+tctrack_forcast_us_timelabel[i]+'</td></tr>';
					label_forcast_us[i]+='<tr><td>Position:</td><td><nobr>'+tctrack_forcast_us_latitude[i]+'N '+ tctrack_forcast_us_longitude[i]+'E</nobr></td></tr>';
					label_forcast_us[i]+='<tr><td><nobr>Distance to HK:</nobr></td><td>'+distanceToHK_forcast_us+'km</td></tr>';
					label_forcast_us[i]+='<tr><td>Category:</td><td>'+tcCategory(nm2km(tctrack_forcast_us_strength[i]))+'</td></tr>';
					label_forcast_us[i]+='<tr><td>Intensity:</td><td>'+nm2km(tctrack_forcast_us_strength[i])+' km/hr</td></tr>';
					label_forcast_us[i]+='</table>';
				}
			}

			if(tctrack_forcast_us_latitude[0]!=''){
				GEvent.addListener(marker_forcast_us[0],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_us_latitude[0],tctrack_forcast_us_longitude[0]), label_forcast_us[0]);
				});
			}

			if(tctrack_forcast_us_latitude[1]!=''){
				GEvent.addListener(marker_forcast_us[1],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_us_latitude[1],tctrack_forcast_us_longitude[1]), label_forcast_us[1]);
				});
			}

			if(tctrack_forcast_us_latitude[2]!=''){
				GEvent.addListener(marker_forcast_us[2],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_us_latitude[2],tctrack_forcast_us_longitude[2]), label_forcast_us[2]);
				});
			}

			if(tctrack_forcast_us_latitude[3]!=''){
				GEvent.addListener(marker_forcast_us[3],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_us_latitude[3],tctrack_forcast_us_longitude[3]), label_forcast_us[3]);
				});
			}

			if(tctrack_forcast_us_latitude[4]!=''){
				GEvent.addListener(marker_forcast_us[4],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_us_latitude[4],tctrack_forcast_us_longitude[4]), label_forcast_us[4]);
				});
			}

			if(tctrack_forcast_us_latitude[5]!=''){
				GEvent.addListener(marker_forcast_us[5],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_us_latitude[5],tctrack_forcast_us_longitude[5]), label_forcast_us[5]);
				});
			}

			if(tctrack_forcast_us_latitude[6]!=''){
				GEvent.addListener(marker_forcast_us[6],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_us_latitude[6],tctrack_forcast_us_longitude[6]), label_forcast_us[6]);
				});
			}
			////////////////////////////////////////////

			////////////////////////////////////////////
			//Japan Track

			var polyline_jp = new GPolyline([
			<?php
				for ($x=0; $x<count($tctrack_forcast_jp_latitude);$x++){
				  print("new GLatLng( $tctrack_forcast_jp_latitude[$x],$tctrack_forcast_jp_longitude[$x]),");
				}
			?>
			], "#FFFF00", 5, 0.7, polyOptions);


			//JP TC Track Icon and Label
			var tcicon_forcast_jp=new GIcon(tcicon_base);
			tcicon_forcast_jp.image="pic/forecast_pos_y.gif";
			tcicon_forcast_jp.iconSize=new GSize(20, 20);
			tcicon_forcast_jp.shadowSize = new GSize(0, 0);
			tcicon_forcast_jp.iconAnchor = new GPoint(10, 10);

			var tcicon_forcast_jp2=new GIcon(tcicon_base);
			tcicon_forcast_jp2.image="pic/forecast_pos_y2.gif";
			tcicon_forcast_jp2.iconSize=new GSize(20, 20);
			tcicon_forcast_jp2.shadowSize = new GSize(0, 0);
			tcicon_forcast_jp2.iconAnchor = new GPoint(10, 10);

			var marker_forcast_jp=[];
			var label_forcast_jp= [];
			var distanceToHK_forcast_jp=0;

			var tctrack_forcast_jp_latitude=[];
			var tctrack_forcast_jp_longitude=[];
			tctrack_forcast_jp_latitude[0]=<?php ($tctrack_forcast_jp_latitude[0]!='')? print($tctrack_forcast_jp_latitude[0]):print('""')?>;
			tctrack_forcast_jp_longitude[0]=<?php ($tctrack_forcast_jp_longitude[0]!='')? print($tctrack_forcast_jp_longitude[0]):print('""')?>;
			tctrack_forcast_jp_latitude[1]=<?php ($tctrack_forcast_jp_latitude[1]!='')? print($tctrack_forcast_jp_latitude[1]):print('""')?>;
			tctrack_forcast_jp_longitude[1]=<?php ($tctrack_forcast_jp_longitude[1]!='')? print($tctrack_forcast_jp_longitude[1]):print('""')?>;
			tctrack_forcast_jp_latitude[2]=<?php ($tctrack_forcast_jp_latitude[2]!='')? print($tctrack_forcast_jp_latitude[2]):print('""')?>;
			tctrack_forcast_jp_longitude[2]=<?php ($tctrack_forcast_jp_longitude[2]!='')? print($tctrack_forcast_jp_longitude[2]):print('""')?>;
			tctrack_forcast_jp_latitude[3]=<?php ($tctrack_forcast_jp_latitude[3]!='')? print($tctrack_forcast_jp_latitude[3]):print('""')?>;
			tctrack_forcast_jp_longitude[3]=<?php ($tctrack_forcast_jp_longitude[3]!='')? print($tctrack_forcast_jp_longitude[3]):print('""')?>;
			tctrack_forcast_jp_latitude[4]=<?php ($tctrack_forcast_jp_latitude[4]!='')? print($tctrack_forcast_jp_latitude[4]):print('""')?>;
			tctrack_forcast_jp_longitude[4]=<?php ($tctrack_forcast_jp_longitude[4]!='')? print($tctrack_forcast_jp_longitude[4]):print('""')?>;
			tctrack_forcast_jp_latitude[5]=<?php ($tctrack_forcast_jp_latitude[5]!='')? print($tctrack_forcast_jp_latitude[5]):print('""')?>;
			tctrack_forcast_jp_longitude[5]=<?php ($tctrack_forcast_jp_longitude[5]!='')? print($tctrack_forcast_jp_longitude[5]):print('""')?>;

			var tctrack_forcast_jp_strength=[];
			tctrack_forcast_jp_strength[0]=<?php ($tctrack_forcast_jp_strength[0]!='')? print($tctrack_forcast_jp_strength[0]):print('""')?>;
			tctrack_forcast_jp_strength[1]=<?php ($tctrack_forcast_jp_strength[1]!='')? print($tctrack_forcast_jp_strength[1]):print('""')?>;
			tctrack_forcast_jp_strength[2]=<?php ($tctrack_forcast_jp_strength[2]!='')? print($tctrack_forcast_jp_strength[2]):print('""')?>;
			tctrack_forcast_jp_strength[3]=<?php ($tctrack_forcast_jp_strength[3]!='')? print($tctrack_forcast_jp_strength[3]):print('""')?>;
			tctrack_forcast_jp_strength[4]=<?php ($tctrack_forcast_jp_strength[4]!='')? print($tctrack_forcast_jp_strength[4]):print('""')?>;
			tctrack_forcast_jp_strength[5]=<?php ($tctrack_forcast_jp_strength[5]!='')? print($tctrack_forcast_jp_strength[5]):print('""')?>;

			var tctrack_forcast_jp_timelabel=[];
			tctrack_forcast_jp_timelabel[0]=' +12hr Forcast by JP<br>HKT: <?php print("$tctrack_forcast_jp_year[0]/$tctrack_forcast_jp_month[0]/$tctrack_forcast_jp_day[0] $tctrack_forcast_jp_hr[0]:0");?>';
			tctrack_forcast_jp_timelabel[1]=' +24hr Forcast by JP<br>HKT: <?php print("$tctrack_forcast_jp_year[1]/$tctrack_forcast_jp_month[1]/$tctrack_forcast_jp_day[1] $tctrack_forcast_jp_hr[1]:0");?>';
			tctrack_forcast_jp_timelabel[2]=' +48hr Forcast by JP<br>HKT: <?php print("$tctrack_forcast_jp_year[2]/$tctrack_forcast_jp_month[2]/$tctrack_forcast_jp_day[2] $tctrack_forcast_jp_hr[2]:0");?>';
			tctrack_forcast_jp_timelabel[3]=' +72hr Forcast by JP<br>HKT: <?php print("$tctrack_forcast_jp_year[3]/$tctrack_forcast_jp_month[3]/$tctrack_forcast_jp_day[3] $tctrack_forcast_jp_hr[3]:0");?>';
			tctrack_forcast_jp_timelabel[4]=' +96hr Forcast by JP<br>HKT: <?php print("$tctrack_forcast_jp_year[4]/$tctrack_forcast_jp_month[4]/$tctrack_forcast_jp_day[4] $tctrack_forcast_jp_hr[4]:0");?>';
			tctrack_forcast_jp_timelabel[5]=' +120hr Forcast by JP<br>HKT: <?php print("$tctrack_forcast_jp_year[5]/$tctrack_forcast_jp_month[5]/$tctrack_forcast_jp_day[5] $tctrack_forcast_jp_hr[5]:0");?>';

			i=0;

			for(i=1; i<6; i++){

				(tctrack_forcast_jp_strength[i]>=118)?markerOptions = { icon:tcicon_forcast_jp2 }:markerOptions = { icon:tcicon_forcast_jp };

				marker_forcast_jp[i] = new GMarker(new GLatLng(tctrack_forcast_jp_latitude[i],tctrack_forcast_jp_longitude[i]), markerOptions);
	
				map.addOverlay(marker_forcast_jp[i]);

				if(tctrack_forcast_jp_latitude[i]!=''){

					distanceToHK_forcast_jp=calculateDistance(tctrack_forcast_jp_latitude[i],tctrack_forcast_jp_longitude[i], 22.3, 114.2);
					label_forcast_jp[i]='<table bordercolor="black" border="1" cellpadding="1" cellspacing="0" width="220"><tr><td colspan="2"><?php print(' ');print($focus_tc_nameeng);?>'+tctrack_forcast_jp_timelabel[i]+'</td></tr>';
					label_forcast_jp[i]+='<tr><td>Position:</td><td><nobr>'+tctrack_forcast_jp_latitude[i]+'N '+ tctrack_forcast_jp_longitude[i]+'E</nobr></td></tr>';
					label_forcast_jp[i]+='<tr><td><nobr>Distance to HK:</nobr></td><td>'+distanceToHK_forcast_jp+'km</td></tr>';
					//label_forcast_jp[i]+='<tr><td>Category:</td><td>'+tcCategory(nm2km(tctrack_forcast_jp_strength[i]))+'</td></tr>';
					//label_forcast_jp[i]+='<tr><td>Intensity:</td><td>'+nm2km(tctrack_forcast_jp_strength[i])+' km/hr</td></tr>';
					label_forcast_jp[i]+='</table>';

				}
			}

			/*
			GEvent.addListener(marker_forcast_jp[0],"mouseover", function() {
				map.openInfoWindowHtml(new GLatLng(tctrack_forcast_jp_latitude[0],tctrack_forcast_jp_longitude[0]), label_forcast_jp[0]);
			});
			*/


			if(tctrack_forcast_jp_latitude[1]!=''){

				GEvent.addListener(marker_forcast_jp[1],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_jp_latitude[1],tctrack_forcast_jp_longitude[1]), label_forcast_jp[1]);
				});

			}


			if(tctrack_forcast_jp_latitude[2]!=''){

				GEvent.addListener(marker_forcast_jp[2],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_jp_latitude[2],tctrack_forcast_jp_longitude[2]), label_forcast_jp[2]);
				});

			}

			if(tctrack_forcast_jp_latitude[3]!=''){

				GEvent.addListener(marker_forcast_jp[3],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_jp_latitude[3],tctrack_forcast_jp_longitude[3]), label_forcast_jp[3]);
				});

			}

			if(tctrack_forcast_jp_latitude[4]!=''){

				GEvent.addListener(marker_forcast_jp[4],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_jp_latitude[4],tctrack_forcast_jp_longitude[4]), label_forcast_jp[4]);
				});

			}


			if(tctrack_forcast_jp_latitude[5]!=''){

				GEvent.addListener(marker_forcast_jp[5],"mouseover", function() {
					map.openInfoWindowHtml(new GLatLng(tctrack_forcast_jp_latitude[5],tctrack_forcast_jp_longitude[5]), label_forcast_jp[5]);
				});

			}


			//Draw map object

			map.addOverlay(createTCCenterMarker(new GLatLng(<?php print($tctrack_current_latitude)?>,<?php print($tctrack_current_longitude)?>),"<?php print($tctrack_positionOrg)?>",<?php print($tc_current_strength)?>));

			<?php

				if($tctrack_current_hk_latitude[0]!=""){
				 print("map.addOverlay(polyline);\n");
				 print("\t\t\t map.addOverlay(polyline2);\n");
				}

				if($tctrack_current_us_latitude[0]!=""){
				 print("\t\t\t map.addOverlay(polyline_us);\n");
				 print("\t\t\t map.addOverlay(polyline_us2);\n");
				}

				if($tctrack_forcast_jp_latitude[0]!=""){
				 print("\t\t map.addOverlay(polyline_jp);\n");
				}
			?>
			////////////////////////////////////////////



            //-- Add 400KM Label ------------------
              var icon_400=new GIcon();
                icon_400.iconSize = new GSize(12, 7);
                icon_400.iconAnchor = new GPoint(6, 3);
                icon_400.infoWindowAnchor = new GPoint(12, 7);
                var desc_400 = "<i><b>400km</b></i>";
                opts_400 = {
                 "icon": icon_400,
                 "clickable": false,
                 "draggable": false,
                 "labelText": desc_400,
                 "labelOffset": new GSize(-50, 0)
                };
                var mark_400 = new LabeledMarker(new GLatLng(21.32,111.0), opts_400); 
                map.addOverlay(mark_400);
            ///////////////////////////////


            //-- Add 200KM Label ------------------
              var icon_200=new GIcon();
                icon_200.iconSize = new GSize(12, 7);
                icon_200.iconAnchor = new GPoint(6, 3);
                icon_200.infoWindowAnchor = new GPoint(12, 7);
                var desc_200 = "<i><b>200km</b></i>";
                opts_200 = {
                 "icon": icon_200,
                 "clickable": false,
                 "draggable": false,
                 "labelText": desc_200,
                 "labelOffset": new GSize(-50, 0)
                };
                var mark_200 = new LabeledMarker(new GLatLng(21.5,113.2), opts_200); 
                map.addOverlay(mark_200);
            ///////////////////////////////
            
             tctime = new GScreenOverlay('textpng.php?text=HKT:<?php print("$tctrack_current_timestr"); ?>',
                                        new GScreenPoint(0.0, 0.95, 'fraction', 'fraction'),  // screenXY
                                        new GScreenPoint(0, 0),  // overlayXY
                                        new GScreenSize(28*7, 15)  // size on screen
                                       );
              map.addOverlay(tctime);

              tcname = new GScreenOverlay("textpng.php?text=<?php print($tc_current_category);print('%20');print($focus_tc_nameeng); ?>",
                                        new GScreenPoint(0.0, 0.90, 'fraction', 'fraction'),  // screenXY
                                        new GScreenPoint(0, 0),  // overlayXY
                                        new GScreenSize(28*5, 15)  // size on screen
                                       );
              map.addOverlay(tcname);

              tcdistance = new GScreenOverlay("textpng.php?text=Distance to HK: "+distanceToHK+"km",
                                        new GScreenPoint(0.0, 0.85, 'fraction', 'fraction'),  // screenXY
                                        new GScreenPoint(0, 0),  // overlayXY
                                        new GScreenSize(28*7, 15)  // size on screen
                                       );
              map.addOverlay(tcdistance);

              tcIntensity = new GScreenOverlay("textpng.php?text=Intensity: <?php if ($tc_current_strength!='') print($tc_current_strength); ?>km/hr",
                                        new GScreenPoint(0.0, 0.80, 'fraction', 'fraction'),  // screenXY
                                        new GScreenPoint(0, 0),  // overlayXY
                                        new GScreenSize(28*6, 15)  // size on screen
                                       );
              map.addOverlay(tcIntensity);


              hkcotext = new GScreenOverlay('textpng.php?text=By hkco.no-ip.org',
                                        new GScreenPoint(0.0, 0.1, 'fraction', 'fraction'),  // screenXY
                                        new GScreenPoint(0, 0),  // overlayXY
                                        new GScreenSize(22*7, 15)  // size on screen
                                       );
              map.addOverlay(hkcotext);

      }
    }
	
	////pan and zoom to fit
	var bounds = new GLatLngBounds();
	/*
	function fit(){
		map.panTo(bounds.getCenter());
		map.setZoom(map.getBoundsZoomLevel(bounds));
	}

	//calling circle drawing function

	function draw(givenRad, givenQuality){
		//map.clearOverlays();
		//bounds = new GLatLngBounds();
		var centre = map.getCenter()
		drawCircle(centre, givenRad, givenQuality);
		//fit();
	}
	*/
	////////////////////////// circle///////////////////////////////
	function drawCircle(map,center, radius, nodes, liColor, liWidth, liOpa, fillColor, fillOpa){
	// Esa 2006
		//calculating km/degree
		var latConv = center.distanceFrom(new GLatLng(center.lat()+0.1, center.lng()))/100;
		var lngConv = center.distanceFrom(new GLatLng(center.lat(), center.lng()+0.1))/100;

		//Loop
		var points = [];
		var step = parseInt(360/nodes)||10;
		for(var i=0; i<=360; i+=step)
		{
		var pint = new GLatLng(center.lat() + (radius/latConv * Math.cos(i * Math.PI/180)), center.lng() +(radius/lngConv * Math.sin(i * Math.PI/180)));
		points.push(pint);
		bounds.extend(pint); //this is for fit function
		}
		fillColor = fillColor||liColor||"#0055ff";
		liWidth = liWidth||2;
		var poly = new GPolygon(points,liColor,liWidth,liOpa,fillColor,fillOpa);
		map.addOverlay(poly);
	}
    </script>

  </head>


  <body onload="initialize()" onunload="GUnload()">
    <div id="map_canvas" style="width: 316px; height: 340px"></div>
    <div id="message"></div>
  </body>
</html>